package com.yaohun.crazyprizepool;

import com.yaohun.crazyprizepool.data.PoolData;
import com.yaohun.crazyprizepool.listener.OpenBoxEvent;
import com.yaohun.crazyprizepool.manager.PoolManager;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class Main extends JavaPlugin {

    private Main plugin;
    private String prefix = "§7[§6四叶草§7] §f";
    private PoolManager poolManager;

    @Override
    public void onEnable() {
        plugin = this;
        poolManager = new PoolManager(this);
        getServer().getPluginManager().registerEvents(new OpenBoxEvent(this),this);
    }

    @Override
    public void onDisable() {
        poolManager.SavePlayerData();
    }

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("crazypool") && sender.isOp()) {
            if (args.length == 1) {
                String fileName = args[0];
                PoolData poolData = poolManager.getPoolData(fileName);
                if (poolData == null) {
                    return true;
                }
                Player player = (Player) sender;
                player.getInventory().addItem(poolData.getItem());
            }
        }
        return true;
    }

    public PoolManager getPoolManager() {
        return poolManager;
    }

    public Main getPlugin() {
        return plugin;
    }

    public String getPrefix() {
        return prefix;
    }

}
