package com.yaohun.crazyprizepool.data;

import com.yaohun.crazyprizepool.Main;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.inventory.ItemStack;

import java.io.File;
import java.util.*;

public class PoolData {
    private String name;
    private ItemStack item;
    private Map<Integer, Map<String, Double>> poolChanceMap;
    private Map<String, ContentData> contentMap;

    public PoolData(Main plugin,String fileName){
        File file = new File(plugin.getDataFolder(),fileName+".yml");
        FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
        this.name = yml.getString("PoolName",fileName);
        this.item = yml.getItemStack("PoolItem");
        Map<String, ContentData> contentDataMap = new HashMap<>();
        ConfigurationSection section = yml.getConfigurationSection("PoolContent");
        for (String poolKey : section.getKeys(false)) {
            contentDataMap.put(poolKey,new ContentData(poolKey,section));
        }
        this.contentMap = contentDataMap;
        ConfigurationSection section1 = yml.getConfigurationSection("FloatChance");
        Map<Integer, Map<String, Double>> integerMapMap = new HashMap<>();
        for (String needKey : section1.getKeys(false)) {
            int needAmount = Integer.parseInt(needKey);
            Map<String, Double> stringDoubleMap = new HashMap<>();
            ConfigurationSection sectionChance = section1.getConfigurationSection(needKey);
            for (String poolKey : sectionChance.getKeys(false)){
                stringDoubleMap.put(poolKey,sectionChance.getDouble(poolKey));
            }
            integerMapMap.put(needAmount,stringDoubleMap);
        }
        this.poolChanceMap = integerMapMap;
    }

    public ItemStack getItem() {
        NBTItem nbt = new NBTItem(item);
        nbt.setString("poolItem",this.name);
        return nbt.getItem();
    }

    // 执行抽奖获取抽奖池序号
    public int getPoolAmount(int playerValue){
        int poolAmount = 0;
        // 假设玩家是5
        // 5: XXXX
        // 10: XXXX
        // 20: XXXX
        // 30: XXXX
        // 遍历
        Map<Integer, Map<String, Double>> chanceMap = this.poolChanceMap;
        // 使用 TreeMap 来自动排序
        Map<Integer, Map<String, Double>> sortedMap = new TreeMap<>(chanceMap);
        for (Map.Entry<Integer, Map<String, Double>> entry : sortedMap.entrySet()) {
            if(playerValue >= entry.getKey()){
                poolAmount =  entry.getKey();
            }else{
                break;
            }
        }
        return poolAmount;
    }

    public String getPoolKey(int poolAmount){
        Map<String,Double> dataMap = this.poolChanceMap.get(poolAmount);
        Map<String, Double> chanceMap = new HashMap<>();
        int a = 0;
        for (String rewardKey : dataMap.keySet()) {
            double chance = dataMap.get(rewardKey);
            chanceMap.put(rewardKey,chance);
            a += chance;
        }
        String poolKey = null;
        Random ran = new Random();
        ran.setSeed(System.currentTimeMillis()+DemonAPI.getRandomInt(80000,1000));
        int b = ran.nextInt(a);
        for (String key : dataMap.keySet()){
            if(chanceMap.get(key) > b){
                poolKey = key;
                break;
            }
            b -= chanceMap.get(key);
        }
        return poolKey;
    }

    public ContentData getContentData(String poolKey){
        if(this.contentMap.get(poolKey) == null){
            return null;
        }
        return this.contentMap.get(poolKey);
    }
}
