package com.yaohun.crazyprizepool.listener;

import com.yaohun.crazyprizepool.Main;
import com.yaohun.crazyprizepool.data.ContentData;
import com.yaohun.crazyprizepool.data.PoolData;
import com.yaohun.crazyprizepool.manager.PoolManager;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;

import java.util.UUID;

public class OpenBoxEvent implements Listener {

    public Main plugin;
    public String prefix;
    public OpenBoxEvent(Main main){
        plugin = main;
        prefix = main.getPrefix();
    }

    @EventHandler
    public void onUse(PlayerInteractEvent e){
        Player p = e.getPlayer();
        UUID uuid = p.getUniqueId();
        ItemStack item = p.getInventory().getItemInMainHand();
        if(!DemonAPI.itemIsNull(item)){
            NBTItem nbt = new NBTItem(item);
            if(nbt.hasKey("poolItem")){
                String poolKey = nbt.getString("poolItem");
                PoolData poolData = plugin.getPoolManager().getPoolData(poolKey);
                if(poolData == null){return;}
                PoolManager manager = plugin.getPoolManager();
                int PlayerAmount = manager.getPlayerPoolAmount(uuid,poolKey);
                // 获取玩家本次打开奖池的奖池概率
                int PoolAmount = poolData.getPoolAmount(PlayerAmount);
                // 获取抽中的是S级、A级、B级、C级
                String PoolKey = poolData.getPoolKey(PoolAmount);
                ContentData contentData = poolData.getContentData(PoolKey);
                if (contentData == null) {
                    return;
                }
                String rewardKey = contentData.Start_CratesKey();
                ItemStack reward_item = contentData.getCratesStack(rewardKey);
                p.getWorld().dropItem(p.getLocation(),reward_item);
                // 为玩家增加打开奖池次数+1
                plugin.getPoolManager().addPlayerPoolAmount(uuid,poolKey,1);
            }
        }
    }
}
